diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/components/SelectedTexturePackListComponent.java b/game/client/src/main/java/net/minecraft/client/gui/options/components/SelectedTexturePackListComponent.java
index 0e8720107..9a65d728f 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/components/SelectedTexturePackListComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/components/SelectedTexturePackListComponent.java
@@ -2,7 +2,6 @@ package net.minecraft.client.gui.options.components;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.ButtonElement;
-import net.minecraft.client.render.font.renderhelper.FontHelper;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.render.texturepack.TexturePack;
 import net.minecraft.client.util.helper.Colors;
@@ -64,10 +63,10 @@ public class SelectedTexturePackListComponent implements OptionsComponent {
     @Override
     public void render(int x, int y, int width, int relativeMouseX, int relativeMouseY) {
         if (selectedPacks.isEmpty()) {
-            FontHelper.renderCentered(Tessellator.instance, I18n.getInstance().translateKey("gui.options.page.texture_packs.label.no_packs"), x + width / 2, y + 4)
+            mc.font.renderCentered(Tessellator.instance, I18n.getInstance().translateKey("gui.options.page.texture_packs.label.no_packs"), x + width / 2, y + 4)
                 .setShadow()
                 .setColor(0x5F7F7F7F)
-                .call(mc.font);
+                .call();
         }
         for (TexturePackButton button : selectedPacks) {
             if (button == draggedButton) continue;
@@ -264,21 +263,21 @@ public class SelectedTexturePackListComponent implements OptionsComponent {
 
             if(format == Global.TEXTURE_PACK_FORMAT) {
                 // Correct version
-                FontHelper.render(Tessellator.instance, this.texturePack.manifest.getName(), x + this.xPos + this.height + 2, y + this.yPos + 1).call(mc.font);
-                FontHelper.render(Tessellator.instance, this.texturePack.manifest.getDescriptionLine1(), x + this.xPos + this.height + 2, y + this.yPos + 12).setColor(0x808080).call(mc.font);
-                FontHelper.render(Tessellator.instance, this.texturePack.manifest.getDescriptionLine2(), x + this.xPos + this.height + 2, y + this.yPos + 22).setColor(0x808080).call(mc.font);
+                mc.font.render(Tessellator.instance, this.texturePack.manifest.getName(), x + this.xPos + this.height + 2, y + this.yPos + 1).call();
+                mc.font.render(Tessellator.instance, this.texturePack.manifest.getDescriptionLine1(), x + this.xPos + this.height + 2, y + this.yPos + 12).setColor(0x808080).call();
+                mc.font.render(Tessellator.instance, this.texturePack.manifest.getDescriptionLine2(), x + this.xPos + this.height + 2, y + this.yPos + 22).setColor(0x808080).call();
             }else if(format == -1) {
                 // Manifest error
-                FontHelper.render(Tessellator.instance, TextFormatting.RED + this.texturePack.manifest.getName(), x + this.xPos + this.height + 2, y + this.yPos + 1).call(mc.font);
-                FontHelper.render(Tessellator.instance, this.texturePack.manifest.getDescriptionLine1(), x + this.xPos + this.height + 2, y + this.yPos + 12).setColor(0x808080).call(mc.font);
-                FontHelper.render(Tessellator.instance, this.texturePack.manifest.getDescriptionLine2(), x + this.xPos + this.height + 2, y + this.yPos + 22).setColor(0x808080).call(mc.font);
+                mc.font.render(Tessellator.instance, TextFormatting.RED + this.texturePack.manifest.getName(), x + this.xPos + this.height + 2, y + this.yPos + 1).call();
+                mc.font.render(Tessellator.instance, this.texturePack.manifest.getDescriptionLine1(), x + this.xPos + this.height + 2, y + this.yPos + 12).setColor(0x808080).call();
+                mc.font.render(Tessellator.instance, this.texturePack.manifest.getDescriptionLine2(), x + this.xPos + this.height + 2, y + this.yPos + 22).setColor(0x808080).call();
                 rgbVersion = Colors.allChatColors[TextFormatting.RED.id].getARGB();
             }else {
                 // Wrong texture pack version
                 I18n i18n = I18n.getInstance();
-                FontHelper.render(Tessellator.instance, TextFormatting.RED + this.texturePack.manifest.getName(), x + this.xPos + this.height + 2, y + this.yPos + 1).call(mc.font);
-                FontHelper.render(Tessellator.instance, i18n.translateKey("gui.options.page.texture_packs.label.outdated_pack.1"), x + this.xPos + this.height + 2, y + this.yPos + 12).setColor(0x808080).call(mc.font);
-                FontHelper.render(Tessellator.instance, i18n.translateKey("gui.options.page.texture_packs.label.outdated_pack.2"), x + this.xPos + this.height + 2, y + this.yPos + 22).setColor(0x808080).call(mc.font);
+                mc.font.render(Tessellator.instance, TextFormatting.RED + this.texturePack.manifest.getName(), x + this.xPos + this.height + 2, y + this.yPos + 1).call();
+                mc.font.render(Tessellator.instance, i18n.translateKey("gui.options.page.texture_packs.label.outdated_pack.1"), x + this.xPos + this.height + 2, y + this.yPos + 12).setColor(0x808080).call();
+                mc.font.render(Tessellator.instance, i18n.translateKey("gui.options.page.texture_packs.label.outdated_pack.2"), x + this.xPos + this.height + 2, y + this.yPos + 22).setColor(0x808080).call();
                 rgbVersion = Colors.allChatColors[TextFormatting.RED.id].getARGB();
             }
 
@@ -289,7 +288,7 @@ public class SelectedTexturePackListComponent implements OptionsComponent {
 
             String version = texturePack.manifest.getPackVersion();
             int versionWidth = mc.font.stringWidth(version);
-            FontHelper.render(Tessellator.instance, this.texturePack.manifest.getPackVersion(), x + this.xPos + width - versionWidth - 2, y + this.yPos + 1).setColor(rgbVersion).call(mc.font);
+            mc.font.render(Tessellator.instance, this.texturePack.manifest.getPackVersion(), x + this.xPos + width - versionWidth - 2, y + this.yPos + 1).setColor(rgbVersion).call();
         }
         public void setupButton(int x, int y, int width, int mouseX, int mouseY){
             button.setX(x + xPos + width - button.width - 1);
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/components/TooltipPickerComponent.java b/game/client/src/main/java/net/minecraft/client/gui/options/components/TooltipPickerComponent.java
index 984d1d2a5..2794b2fb7 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/components/TooltipPickerComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/components/TooltipPickerComponent.java
@@ -21,10 +21,8 @@ public class TooltipPickerComponent
     protected void renderButton(final int x, final int y, final int relativeButtonX, final int relativeButtonY, final int buttonWidth, final int buttonHeight, final int relativeMouseX, final int relativeMouseY) {
         super.renderButton(x, y, relativeButtonX, relativeButtonY, buttonWidth, buttonHeight, relativeMouseX, relativeMouseY);
 
-        final int padding = 3;
-        final int yOffset = 0;
         final int stringWidth = mc.font.stringWidth(this.option.getDisplayStringValue());
-        final int stringHeight = mc.font.fontHeight();
+        final int stringHeight = mc.font.getFont().fontHeight();
         GL11.glColor4f(1, 1, 1, 1);
         this.tooltip.render(this.option.getDisplayStringValue(), x + relativeButtonX + buttonWidth/2 - stringWidth/2, y + relativeButtonY + buttonHeight/2 - stringHeight/2, 0, 0, -1, -1, false);
 
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java b/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
index d520763ea..c473d621b 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
@@ -70,6 +70,7 @@ public abstract class OptionsPages
                 .withComponent(new IntegerOptionComponent(mc.gameSettings.guiScale))
                 .withComponent(new FloatOptionComponent(mc.gameSettings.screenPadding))
                 .withComponent(new TooltipPickerComponent(mc.gameSettings.tooltipStyle))
+                .withComponent(new ToggleableOptionComponent<>(mc.gameSettings.font))
                 .withComponent(new ToggleableOptionComponent<>(mc.gameSettings.chatVisibility))
                 .withComponent(new BooleanOptionComponent(mc.gameSettings.fpsInOverlay))
                 .withComponent(new BooleanOptionComponent(mc.gameSettings.versionInOverlay))
@@ -84,7 +85,6 @@ public abstract class OptionsPages
             .withComponent(new OptionsCategory("gui.options.page.general.category.miscellaneous")
                 .withComponent(new BooleanOptionComponent(mc.gameSettings.discordRichPresence))
                 .withComponent(new BooleanOptionComponent(mc.gameSettings.enableItemClumping))
-                .withComponent(new BooleanOptionComponent(mc.gameSettings.forceUnicodeFont))
                 .withComponent(new FloatOptionComponent(mc.gameSettings.autosaveTimer))
             )
             .withComponent(new ShortcutComponent("gui.options.page.general.button.open_worlds_folder", () -> FileOpener.open(new File(mc.getMinecraftDir(), "saves"))))
diff --git a/game/client/src/main/java/net/minecraft/client/gui/popup/LabelComponent.java b/game/client/src/main/java/net/minecraft/client/gui/popup/LabelComponent.java
index 362e4629f..03cf664d0 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/popup/LabelComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/popup/LabelComponent.java
@@ -2,7 +2,6 @@ package net.minecraft.client.gui.popup;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.font.FontRenderer;
-import net.minecraft.client.render.font.renderhelper.FontHelper;
 import net.minecraft.client.render.tessellator.Tessellator;
 
 public class LabelComponent
@@ -28,6 +27,6 @@ public class LabelComponent
     @Override
     public void render(final int x, final int y, final int mouseX, final int mouseY) {
         final int middle = (x - PopupScreen.HORIZONTAL_MARGIN) + getWidth() / 2;
-        FontHelper.renderCentered(Tessellator.instance, this.text, middle, y).setShadow().setColor(this.color).call(this.fontRenderer);
+        this.fontRenderer.renderCentered(Tessellator.instance, this.text, middle, y).setShadow().setColor(this.color).call();
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/popup/MessageBoxComponent.java b/game/client/src/main/java/net/minecraft/client/gui/popup/MessageBoxComponent.java
index 52d0dac0c..8d2dc435e 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/popup/MessageBoxComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/popup/MessageBoxComponent.java
@@ -2,7 +2,6 @@ package net.minecraft.client.gui.popup;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.Scissor;
-import net.minecraft.client.render.font.renderhelper.FontHelper;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.core.util.helper.MathHelper;
@@ -127,7 +126,7 @@ public class MessageBoxComponent
         // Draw lines
         for (int i = 0; i < lines.size(); i++)
         {
-            FontHelper.render(Tessellator.instance, lines.get(i),x + 4,(y + 4) + (i * 12) - getScrollPixels()).setShadow().call(this.minecraft.font);
+            this.minecraft.font.render(Tessellator.instance, lines.get(i),x + 4,(y + 4) + (i * 12) - getScrollPixels()).setShadow().call();
         }
 
         Scissor.disable();
diff --git a/game/client/src/main/java/net/minecraft/client/option/GameSettings.java b/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
index 322e568c7..20f0168ff 100644
--- a/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
+++ b/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
@@ -18,6 +18,8 @@ import net.minecraft.client.gui.TooltipElement;
 import net.minecraft.client.gui.hud.component.HudComponents;
 import net.minecraft.client.input.InputDevice;
 import net.minecraft.client.option.enums.Colorblindness;
+import net.minecraft.client.render.font.Font;
+import net.minecraft.client.render.font.Fonts;
 import net.minecraft.core.enums.ChatVisibility;
 import net.minecraft.core.enums.Difficulty;
 import net.minecraft.client.option.enums.LightmapStyle;
@@ -102,7 +104,6 @@ public class GameSettings {
 	public OptionBoolean showCollisionBoxes = new OptionBoolean(this, "showCollisionBoxes", false);
 	public OptionBoolean swapCraftingButtons = new OptionBoolean(this, "swapCraftingButtons", false);
 	public OptionBoolean forceOnscreenKeyboard = new OptionBoolean(this, "forceOnscreenKeyboard", false);
-    public OptionBoolean forceUnicodeFont = new OptionBoolean(this, "forceUnicodeFont", false);
 	public OptionEnum<PlacementMode> placementMode = new OptionEnum<>(this, "placementMode", PlacementMode.class, PlacementMode.DEFAULT).setIsSlider(false);
 	public OptionBoolean discordRichPresence = new OptionBoolean(this, "discordRichPresence", false);
 	public OptionImmersiveMode immersiveMode = new OptionImmersiveMode(this);
@@ -164,6 +165,7 @@ public class GameSettings {
 	public OptionBoolean borderlessFullscreen = new OptionBoolean(this, "borderlessFullscreen", true);
 	public OptionBoolean startInFullscreen = new OptionBoolean(this, "startInFullscreen", true);
 	public OptionTooltip tooltipStyle = new OptionTooltip(this, "tooltipStyle", "default");
+	public OptionFont font = new OptionFont(this, "font", Fonts.DEFAULT);
 	public OptionEnum<LightmapStyle> lightmapStyle = new OptionEnum<>(this, "lightmapStyle", LightmapStyle.class, LightmapStyle.GRAY);
 	public OptionBoolean customLightmap = new OptionBoolean(this, "customLightmap", true);
 	public OptionBoolean fog = new OptionBoolean(this, "fog", true);
@@ -414,6 +416,9 @@ public class GameSettings {
 			}
 			return "Unknown";
 		}
+		if (option == this.font) {
+			return trans.translateKey("options.font." + this.font.value.getKey());
+		}
 		if (option instanceof OptionBoolean) {
 			Boolean flag = (Boolean) option.value;
 			if (flag) {
diff --git a/game/client/src/main/java/net/minecraft/client/option/OptionFont.java b/game/client/src/main/java/net/minecraft/client/option/OptionFont.java
new file mode 100644
index 000000000..588d258d1
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/option/OptionFont.java
@@ -0,0 +1,54 @@
+package net.minecraft.client.option;
+
+import net.minecraft.client.render.dynamictexture.DynamicTexture;
+import net.minecraft.client.render.font.Font;
+import net.minecraft.client.render.font.Fonts;
+import net.minecraft.core.util.helper.Toggleable;
+import org.jetbrains.annotations.NotNull;
+
+public class OptionFont extends OptionToggleable<@NotNull Font> implements Toggleable {
+
+    public OptionFont(final GameSettings gameSettings, final String name, final @NotNull Font defaultValue) {
+        super(gameSettings, name, defaultValue, null);
+    }
+
+    @Override
+    public void parse(final String string) {
+        this.value = Fonts.fontWithKey(string);
+    }
+
+    @Override
+    public void toggle() {
+        this.value = Fonts.fontAtIndex((getValueIndex() + 1) % size());
+    }
+
+    @Override
+    public void toggle(final int delta) {
+        this.value = Fonts.fontAtIndex(DynamicTexture.pmod(getValueIndex() + delta, size()));
+    }
+
+    @Override
+    public int getValueIndex() {
+        return Fonts.indexForFont(this.value);
+    }
+
+    @Override
+    public void setValueWithIndex(final int i) {
+        this.value = Fonts.fontAtIndex(i);
+    }
+
+    @Override
+    public int size() {
+        return Fonts.fontAmount();
+    }
+
+    @Override
+    public boolean isSlider() {
+        return true;
+    }
+
+    @Override
+    public String getValueString() {
+        return this.value.getKey();
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/LoadingScreenRenderer.java b/game/client/src/main/java/net/minecraft/client/render/LoadingScreenRenderer.java
index 8f70c5cb5..5147e0bf7 100644
--- a/game/client/src/main/java/net/minecraft/client/render/LoadingScreenRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/LoadingScreenRenderer.java
@@ -5,7 +5,6 @@ import static org.lwjgl.opengl.GL11.*;
 import java.util.List;
 import java.util.Random;
 
-import net.minecraft.client.render.font.renderhelper.FontHelper;
 import org.lwjgl.opengl.GL11;
 
 import net.minecraft.client.Minecraft;
@@ -208,11 +207,11 @@ public class LoadingScreenRenderer
         }
 
         // Draw title and stage
-        FontHelper.renderCentered(t, this.title, width / 2, height / 2 - 4 - 16).setShadow().call(this.minecraft.font);
-        FontHelper.renderCentered(t, this.stage, width / 2, (height / 2 - 4) + 8).setShadow().call(this.minecraft.font);
+        this.minecraft.font.renderCentered(t, this.title, width / 2, height / 2 - 4 - 16).setShadow().call();
+        this.minecraft.font.renderCentered(t, this.stage, width / 2, (height / 2 - 4) + 8).setShadow().call();
 
         // Draw tip
-        FontHelper.renderCentered(t, this.tip, width / 2, (height / 2 - 4) + 32).setShadow().call(this.minecraft.font);
+        this.minecraft.font.renderCentered(t, this.tip, width / 2, (height / 2 - 4) + 32).setShadow().call();
 
         this.minecraft.renderer.endRenderGame(1.0f);
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/TextureManager.java b/game/client/src/main/java/net/minecraft/client/render/TextureManager.java
index e0071feb7..22f510e6c 100644
--- a/game/client/src/main/java/net/minecraft/client/render/TextureManager.java
+++ b/game/client/src/main/java/net/minecraft/client/render/TextureManager.java
@@ -33,8 +33,7 @@ import net.minecraft.client.render.dynamictexture.DynamicTextureLavaStill;
 import net.minecraft.client.render.dynamictexture.DynamicTextureTrommel;
 import net.minecraft.client.render.dynamictexture.DynamicTextureWaterFlow;
 import net.minecraft.client.render.dynamictexture.DynamicTextureWaterStill;
-import net.minecraft.client.render.font.FontDefault;
-import net.minecraft.client.render.font.FontRendererDefault;
+import net.minecraft.client.render.font.Fonts;
 import net.minecraft.client.render.texture.meta.AnimationProperties;
 import net.minecraft.client.render.texture.stitcher.AtlasStitcher;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
@@ -410,7 +409,7 @@ public class TextureManager {
 
 		Colors.loadColors();
 
-        this.mc.font.init(this.mc.texturePackList);
+		Fonts.refreshFonts(this.mc.texturePackList);
 
 		mc.skinVariantList.refresh(errors);
 		mc.mainMenuBackground.refresh(errors);
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRenderer.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRenderer.java
index 63392a634..3a49016bd 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRenderer.java
@@ -4,7 +4,6 @@ import com.mojang.logging.LogUtils;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.font.FontRenderer;
-import net.minecraft.client.render.font.renderhelper.FontHelper;
 import net.minecraft.client.render.model.ModelBase;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.Global;
@@ -248,10 +247,10 @@ public class MobRenderer<T extends Mob> extends EntityRenderer<T>
         t.addVertex(j + 1, -1 + byte0, 0.0D);
         t.draw();
         GL11.glEnable(3553 /* GL_TEXTURE_2D */);
-        FontHelper.render(t, s, -sr.stringWidth(s) / 2, byte0).setColor(0x20ffffff).call(sr);
+        sr.render(t, s, -sr.stringWidth(s) / 2, byte0).setColor(0x20ffffff).call();
         if (!depthTest) GL11.glEnable(2929 /* GL_DEPTH_TEST */);
         GL11.glDepthMask(true);
-        FontHelper.render(t, s, -sr.stringWidth(s) / 2, byte0).setColor(0xFFFFFF).call(sr);
+        sr.render(t, s, -sr.stringWidth(s) / 2, byte0).setColor(0xFFFFFF).call();
         GL11.glEnable(2896 /* GL_LIGHTING */);
         GL11.glDisable(3042 /* GL_BLEND */);
         GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPlayer.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPlayer.java
index 4ed76a5e9..0a7a0c9d7 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPlayer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPlayer.java
@@ -8,7 +8,6 @@ import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.PlayerSkinParser;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
 import net.minecraft.client.render.font.FontRenderer;
-import net.minecraft.client.render.font.renderhelper.FontHelper;
 import net.minecraft.client.render.tileentity.TileEntityRenderer;
 import net.minecraft.client.render.camera.EntityCamera;
 import net.minecraft.client.render.model.ModelPlayer;
@@ -164,7 +163,7 @@ public class MobRendererPlayer extends MobRendererBipedArmored<Player>
                     t.draw();
                     GL11.glEnable(GL11.GL_TEXTURE_2D);
                     GL11.glDepthMask(true);
-                    FontHelper.renderCentered(t, s, 0, 0).setColor(0x20ffffff).call(font);
+                    font.renderCentered(t, s, 0, 0).setColor(0x20ffffff).call();
                     GL11.glEnable(GL11.GL_LIGHTING);
                     GL11.glDisable(GL11.GL_BLEND);
                     GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
diff --git a/game/client/src/main/java/net/minecraft/client/render/font/Font.java b/game/client/src/main/java/net/minecraft/client/render/font/Font.java
index bdc0c87fd..1cdd19a31 100644
--- a/game/client/src/main/java/net/minecraft/client/render/font/Font.java
+++ b/game/client/src/main/java/net/minecraft/client/render/font/Font.java
@@ -11,6 +11,8 @@ public interface Font {
 
     void init(@NotNull TexturePackList packList);
 
+    @NotNull String getKey();
+
     int textureForChar(char c);
     char getObfuscatedChar(char c, Random random);
     boolean canRenderChar(char c);
diff --git a/game/client/src/main/java/net/minecraft/client/render/font/FontDefault.java b/game/client/src/main/java/net/minecraft/client/render/font/FontDefault.java
index a10d064a5..fe7abeb4b 100644
--- a/game/client/src/main/java/net/minecraft/client/render/font/FontDefault.java
+++ b/game/client/src/main/java/net/minecraft/client/render/font/FontDefault.java
@@ -1,14 +1,14 @@
 package net.minecraft.client.render.font;
 
-import net.minecraft.client.render.TextureManager;
+import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.render.texture.Texture;
 import net.minecraft.core.util.helper.ChatAllowedCharacters;
 import org.jetbrains.annotations.NotNull;
 
 public class FontDefault extends FontFile {
-    public FontDefault(final @NotNull TextureManager textureManager) {
-        super(textureManager, "/font/font_%02X.png", "/font/glyph_sizes_default.bin");
+    public FontDefault(@NotNull final String key) {
+        super(key, "/assets/minecraft/textures/gui/font/default/font_%02X.png", "/assets/minecraft/textures/gui/font/default/glyph_sizes.bin");
     }
 
     @Override
@@ -23,7 +23,7 @@ public class FontDefault extends FontFile {
         if (fontIndex < 0) return 0;
         final int index = fontIndex / GLYPHS_PER_TEXTURE;
         if (this.texHandleCache[index] != TEXTURE_UNASSIGNED) return this.texHandleCache[index];
-        final Texture texture = this.textureManager.loadTextureNoDefault(String.format(this.textureFormat, index));
+        final Texture texture = Minecraft.getMinecraft().textureManager.loadTextureNoDefault(String.format(this.textureFormat, index));
         if (texture == null) {
             this.texHandleCache[index] = 0;
             return 0;
@@ -43,7 +43,7 @@ public class FontDefault extends FontFile {
         final double fUpper = upper;
         final double fLower = (lower + 1);
 
-        return (fLower - fUpper) / 2.0D + 1;
+        return (fLower - fUpper) / 2d + 1;
     }
 
     @Override
@@ -78,6 +78,6 @@ public class FontDefault extends FontFile {
         tessellator.addVertexWithUV(x - shift,          y + height,  z, uMin + epsilon, vMax - epsilon);
         tessellator.addVertexWithUV(x - shift + width,  y + height,  z, uMax - epsilon, vMax - epsilon);
         tessellator.addVertexWithUV(x + shift + width,  y,           z, uMax - epsilon, vMin + epsilon);
-        return (fLower - fUpper)/2 + 1;
+        return (fLower - fUpper)/2d + 1;
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/font/FontFile.java b/game/client/src/main/java/net/minecraft/client/render/font/FontFile.java
index a19072aff..be72ac583 100644
--- a/game/client/src/main/java/net/minecraft/client/render/font/FontFile.java
+++ b/game/client/src/main/java/net/minecraft/client/render/font/FontFile.java
@@ -1,6 +1,6 @@
 package net.minecraft.client.render.font;
 
-import net.minecraft.client.render.TextureManager;
+import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.render.texture.Texture;
 import net.minecraft.client.render.texturepack.TexturePackList;
@@ -31,10 +31,11 @@ public class FontFile implements Font {
 
     protected final @NotNull String textureFormat;
     protected final @NotNull String glyphSizesPath;
-    protected final @NotNull TextureManager textureManager;
 
-    public FontFile(final @NotNull TextureManager textureManager, @NotNull final String texturesFormat, @NotNull final String glyphSizesPath) {
-        this.textureManager = textureManager;
+    protected final @NotNull String key;
+
+    public FontFile(@NotNull final String key, @NotNull final String texturesFormat, @NotNull final String glyphSizesPath) {
+        this.key = key;
         this.textureFormat = texturesFormat;
         this.glyphSizesPath = glyphSizesPath;
         this.charWidth = new byte[Character.MAX_VALUE + 1];
@@ -52,11 +53,16 @@ public class FontFile implements Font {
         }
     }
 
+    @Override
+    public @NotNull String getKey() {
+        return this.key;
+    }
+
     @Override
     public int textureForChar(final char c) {
         final int index = c / GLYPHS_PER_TEXTURE;
         if (this.texHandleCache[index] != TEXTURE_UNASSIGNED) return this.texHandleCache[index];
-        final Texture texture = this.textureManager.loadTextureNoDefault(String.format(this.textureFormat, index));
+        final Texture texture = Minecraft.getMinecraft().textureManager.loadTextureNoDefault(String.format(this.textureFormat, index));
         if (texture == null) {
             this.texHandleCache[index] = 0;
             return 0;
@@ -93,7 +99,7 @@ public class FontFile implements Font {
         final double fUpper = upper;
         final double fLower = (lower + 1);
 
-        return (fLower - fUpper) / 2.0D + 1;
+        return (fLower - fUpper) / 2d + 1;
     }
 
     @Override
@@ -130,6 +136,6 @@ public class FontFile implements Font {
         tessellator.addVertexWithUV(x - shift,          y + height,  z, uMin + epsilon, vMax - epsilon);
         tessellator.addVertexWithUV(x - shift + width,  y + height,  z, uMax - epsilon, vMax - epsilon);
         tessellator.addVertexWithUV(x + shift + width,  y,           z, uMax - epsilon, vMin + epsilon);
-        return (fLower - fUpper)/2 + 1;
+        return (fLower - fUpper)/2d + 1;
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/font/FontMonospace.java b/game/client/src/main/java/net/minecraft/client/render/font/FontMonospace.java
index 84e168513..fbb29546b 100644
--- a/game/client/src/main/java/net/minecraft/client/render/font/FontMonospace.java
+++ b/game/client/src/main/java/net/minecraft/client/render/font/FontMonospace.java
@@ -1,6 +1,5 @@
 package net.minecraft.client.render.font;
 
-import net.minecraft.client.render.TextureManager;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.render.texturepack.TexturePackList;
 import net.minecraft.core.util.helper.ChatAllowedCharacters;
@@ -11,8 +10,8 @@ import java.util.Arrays;
 public class FontMonospace extends FontFile{
     public static final int MONOSPACE_WIDTH = 10;
 
-    public FontMonospace(final @NotNull TextureManager textureManager) {
-        super(textureManager, "/font/mono_%02X.png", "");
+    public FontMonospace(@NotNull final String key) {
+        super(key, "/assets/minecraft/textures/gui/font/monospace/mono_%02X.png", "");
     }
 
     @Override
